## soundscaperenderer 0.6.1+dfsg

=== flext/Makefile ===
# Makefile to generate externals for Puredata

PKG_CONFIG ?= pkg-config

cflags += \
       -DFLEXT_INLINE \
       -Iflext/source \
       -I../apf \
       -I../src \
       -I../gml/include \
       `$(PKG_CONFIG) --cflags libxml-2.0` \
       -std=c++17 \
       -DENABLE_SOFA \
       -DNDEBUG \

define forDarwin
  cflags += -mmacosx-version-min=10.15
endef

ldlibs = -lfftw3f -lsndfile -lmysofa `$(PKG_CONFIG) --libs libxml-2.0`

class.sources = \
	ssr_aap~.cpp \
	ssr_binaural~.cpp \
	ssr_brs~.cpp \
	ssr_dca~.cpp \
	ssr_wfs~.cpp \
	ssr_vbap~.cpp \

common.sources = \
	legacy_position.cpp \
	legacy_orientation.cpp \
	legacy_directionalpoint.cpp \
	ssr_global.cpp \
	xmlparser.cpp \

datafiles = \
	$(wildcard *-help.pd) \
	ssr_messages.pd \
	8channels.asd \
	circle.asd \
	hrirs_fabian_min_phase_eq.wav \
	wfs_prefilter_120_1500_44100.wav \
	brirs_1.wav \
	brirs_2.wav \

include pd-lib-builder/Makefile.pdlibbuilder

=== mex/DESCRIPTION ===
Name: SoundScape Renderer
Version:
Date:
Author:
Maintainer:
Title: SSR as MEX files
Description:
Categories:
Problems:
Url: http://spatialaudio.net/ssr/
Autoload:
Depends:
License: GPLv3+
SystemRequirements:
BuildRequires:
SVNRelease:

=== mex/Makefile ===
# Makefile for building MEX-files

# Makefile example:
# http://www.klab.caltech.edu/~harel/share/gbvs_scale/sift/Makefile

MEXFILES ?= ssr_dca ssr_binaural ssr_vbap ssr_aap ssr_wfs ssr_generic \
  ssr_brs

OBJECTS := ssr_global legacy_position legacy_orientation \
  legacy_directionalpoint xmlparser

LIBRARIES += libxml-2.0 fftw3f sndfile

APF_DIR ?= ../apf
GML_DIR ?= ../gml/include
SRC_DIR ?= ../src
MEX ?= mex -v
OCT ?= mkoctfile --mex --verbose

CXXFLAGS += -std=c++17

# optimization:
CXXFLAGS_OPT += -O3
#CXXFLAGS_OPT += -fomit-frame-pointer -ffast-math -funroll-loops
#CXXFLAGS_OPT += -march=native
CPPFLAGS += -DNDEBUG
# TODO: check for SSE?

CXXFLAGS += -pthread

# TODO: this works for 64bit systems, check if it also works on 32bit
CXXFLAGS += -fPIC

# maybe for Mac OS X:
#CFLAGS += -fno-common -no-cpp-precomp -fexceptions

#CPPFLAGS += -DSSR_MEX_USE_DOUBLE

# show many warnings
CXXFLAGS += -Wall -Wextra
CXXFLAGS += -pedantic
# warnings are errors
CXXFLAGS += -pedantic-errors
CXXFLAGS += -Werror
# even more warnings:
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wcast-align
CXXFLAGS += -Wwrite-strings
CXXFLAGS += -Wredundant-decls
#CXXFLAGS += -Wlong-long
#CXXFLAGS += -Wconversion
#CXXFLAGS += -Wsign-conversion
#CXXFLAGS += -Wshadow
#CXXFLAGS += -Wold-style-cast
#CXXFLAGS += -Winline

PKG_CONFIG ?= pkg-config
LDLIBS += `$(PKG_CONFIG) --libs $(LIBRARIES)`
CPPFLAGS += `$(PKG_CONFIG) --cflags $(LIBRARIES)`

CPPFLAGS += -I$(APF_DIR) -I$(SRC_DIR) -I$(GML_DIR)

OCTAVE_TARGETS := $(MEXFILES:%=%.octave)
MATLAB_TARGETS := $(MEXFILES:%=%.matlab)

OBJECTS := $(OBJECTS:%=%.o)

CXXFLAGS += $(CXXFLAGS_OPT)

# prevent make from deleting intermediate files:
.SECONDARY:

vpath %.cpp $(SRC_DIR)

all:
	$(MAKE) octave
	$(MAKE) matlab

octave: $(OCTAVE_TARGETS)

matlab: $(MATLAB_TARGETS)

# Rebuild objects if Makefile has changed:
$(OBJECTS): Makefile

# Targets have different extension depending on the platform.
# To avoid finding out the extension, we use empty *.stamp files.

$(OCTAVE_TARGETS) $(MATLAB_TARGETS): %: %.stamp

STAMPFILES := $(OCTAVE_TARGETS:%=%.stamp) $(MATLAB_TARGETS:%=%.stamp)

%.octave.stamp: %.cpp $(OBJECTS) | Makefile
	CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)" $(OCT) $(CPPFLAGS) $(LDLIBS) $< \
	    $(filter %.o, $^)
	@touch $@

# TODO: somehow add -O3 to linking step

%.matlab.stamp: %.cpp $(OBJECTS) | Makefile
	$(MEX) $(CPPFLAGS) $(LDLIBS) CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)" \
	    CXXOPTIMFLAGS="$(CXXFLAGS_OPT)" LDOPTIMFLAGS="$(CXXFLAGS_OPT)" $< \
	    $(filter %.o, $^)
	@touch $@

# Reminder: to specify MEX file name: -output bla

clean:
	$(RM) $(MEXFILES:%=%.mexa64)
	$(RM) $(MEXFILES:%=%.mexglx)
	$(RM) $(MEXFILES:%=%.mexmaci)
	$(RM) $(MEXFILES:%=%.mexmaci64)
	$(RM) $(MEXFILES:%=%.mex)
	$(RM) $(MEXFILES:%=%.o)  # mkoctfile creates these
	$(RM) $(OBJECTS)
	$(RM) $(STAMPFILES)

.PHONY: all octave matlab clean $(OCTAVE_TARGETS) $(MATLAB_TARGETS)

.DELETE_ON_ERROR:

DEPENDENCIES := $(OBJECTS) $(STAMPFILES)
BINARY_EXTENSIONS := .o .octave.stamp .matlab.stamp
include ../apf/misc/Makefile.dependencies

=== debian/changelog ===
soundscaperenderer (0.6.1+dfsg-3) unstable; urgency=medium

  * Team Upload
  * Remove obsolete dh-buildinfo build dependency
  * Remove CDBS leftovers

 -- Alexandre Detiste <tchet@debian.org>  Sun, 17 Aug 2025 20:18:26 +0200

soundscaperenderer (0.6.1+dfsg-2) unstable; urgency=medium

  * Symlink to upstream's NEWS (rather than changelog) (Closes: #1040390)
  * B-D on 'pkgconf'
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 12 Aug 2024 14:32:16 +0200

soundscaperenderer (0.6.1+dfsg-1) unstable; urgency=medium

  * New upstream version 0.6.1+dfsg
    + Refresh patches
  * B-D on libmysofa-dev, libfmt-dev
  * Disable ASDF support
    + Re-emable this, once ASDF has been packaged for Debian
  * Update copyright information
    + Refresh copyright dates
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 10 Jul 2023 15:29:41 +0200

=== debian/control ===
Source: soundscaperenderer
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libfftw3-dev,
 libjack-dev | libjack-jackd2-dev,
 libsndfile1-dev,
 libxml2-dev,
 pkgconf | pkg-config,
Build-Depends-Arch:
 libasio-dev,
 libecasoundc-dev,
 libfmt-dev,
 libmysofa-dev,
 libqt5opengl5-dev [!armel !armhf],
 libwebsocketpp-dev,
 rapidjson-dev,
Build-Depends-Indep:
 python3-sphinx,
 python3-sphinx-rtd-theme,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: http://spatialaudio.net/ssr/
Vcs-Git: https://salsa.debian.org/multimedia-team/soundscaperenderer.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/soundscaperenderer

Package: soundscaperenderer-nox
Architecture: any
Depends:
 jackd,
 soundscaperenderer-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ecasound,
Description: tool for real-time spatial audio reproduction (without X support)
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains a version of SSR compiled without X support.

Package: soundscaperenderer
Architecture: any
Depends:
 jackd,
 soundscaperenderer-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ecasound,
Description: tool for real-time spatial audio reproduction
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains a version of SSR compiled with graphical interface using
 Qt.

Package: soundscaperenderer-common
Architecture: all
Multi-Arch: foreign
Breaks:
 soundscaperenderer (<< 0.5.0~dfsg-5~),
Replaces:
 soundscaperenderer (<< 0.5.0~dfsg-5~),
Depends:
 ${misc:Depends},
Recommends:
 soundscaperenderer | soundscaperenderer-nox,
Description: tool for real-time spatial audio reproduction (common-files)
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains common files for all flavours of SSR.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2014-2022 IOhannes m zmölnig <zmoelnig@iem.at>
# Description: Main Debian packaging script for SoundScape Renderer
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

## some archs only have OpenGL-ES (at least with Qt):
OPENGL_ES_ARCHS := armhf armel

# needs to be declared before including makefile.mk
FLAVORS = nox
ifneq (,$(findstring $(DEB_HOST_ARCH), $(OPENGL_ES_ARCHS)))
export DH_OPTIONS=-Nsoundscaperenderer
else
FLAVORS += qt
endif
builddir=debian/build/flavor-

DEB_BUILDDIR = build

export QT_SELECT=qt5

# global configure options
## disables all optimization
## (x86_64 should be turned on automatically by the compiler)
CONFIG = --disable-optimization \
	--disable-dynamic-asdf \
	$(empty)
# per flavor configure options
CONFIG_qt  = --enable-gui  --program-suffix=.qt
CONFIG_nox = --disable-gui --program-suffix=.nox
CONFIG_indep = --program-suffix=.indep --disable-all \
	--disable-gui \
	--disable-ip-interface \
	--disable-websocket-interface \
	--disable-ecasound \
	--disable-polhemus \
	--disable-razor \
	--disable-vrpn \
	--disable-intersense \
	--disable-isatty \
	$(empty)


# Use the default debhelper scripts, where possible.
%:
	dh $@

execute_before_dh_autoreconf:
	mkdir -p autotools/config autotools/m4

# Add configuration options:
override_dh_auto_configure-indep: configure_indep
override_dh_auto_configure-arch: $(patsubst %,configure_%,$(FLAVORS))
configure_%:
	dh_auto_configure -B $(builddir)$* -- $(strip $(CONFIG) $(CONFIG_$*))

# Remove the subdirectories generated for the flavors.
override_dh_auto_clean:
	rm -rf $(patsubst %,$(builddir)%,$(FLAVORS) indep)
	rmdir -p $(dir $(builddir)) || echo "couldn't cleanup build-dirs...ignoring"
	rm -rf doc/manual/_build/

override_dh_auto_build-indep:
	dh_auto_build -i --sourcedirectory=$(builddir)indep || (cat $(builddir)indep/config.log && exit 1)
	$(CURDIR)/debian/scripts/alternatives $(CURDIR)/$(builddir)indep/src $(CURDIR)/$(builddir)indep/alternatives
# Create sphinx documentation:
	make -C $(CURDIR)/doc/manual html
override_dh_auto_build-arch: $(patsubst %,build_%,$(FLAVORS))
build_%:
	dh_auto_build -a --sourcedirectory=$(builddir)$* || (cat $(builddir)$*/config.log && exit 1)
	$(CURDIR)/debian/scripts/alternatives $(CURDIR)/$(builddir)$*/src $(CURDIR)/$(builddir)$*/alternatives

override_dh_auto_install-indep:
	dh_auto_install -i --sourcedirectory=$(builddir)indep
override_dh_auto_install-arch: $(patsubst %,install_%,$(FLAVORS))
install_%:
	dh_auto_install -a --sourcedirectory=$(builddir)$*

override_dh_installman:
	dh_installman --language=C

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|flext/.*\.wav|data/impulse_responses/hrirs/.*\.wav|doc/manual/images/screenshot.*\.png|data/MacOSX/SSRIcon\.icns|data/MacOSX/\.background/background\.png|data/MacOSX/dylibbundler/dylibbundler\.png
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints
